<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/**
 * Template Library
 *
 * @author      Deep Arora
 * @copyright   Copyright (c) SiteManPro.com
 *
 */

class Template
{
	private $CI;

	public function __construct()
	{
		$this->CI =& get_instance();
	}

	public function set($var_name='', $value='')
	{
		if (!empty($var_name))
		{
			$this->data[$var_name] = $value;
		}
	}

        public function view($view_name, $layout = 'application')
	{
                $this->data['rendered_view'] = $this->CI->parser->parse($view_name, $this->data, TRUE);
                $this->CI->parser->parse('layouts/' . $layout, $this->data);
	}

}


/* End of file Template.php */
/* Location: ./application/libraries/Template.php */