<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Module_config {

        var $app_version = '1.0';
        var $app_name = 'config';
        var $app_title = 'Config';
        var $app_folder = 'config';
        var $app_description = 'Author: Deep Arora <br> Support: <a href=http://sitemanpro.com/community target=_New>Click here</a> <br> Used for core configuration.';

        /**************************************************/
        /***************  GETTER FUNCTIONS ****************/
        /**************************************************/
        function get_version()
        {
            return $this->app_version;
        }
        function get_app_name()
        {
            return $this->app_name;
        }
        function get_app_title()
        {
            return $this->app_title;
        }
        function get_app_description()
        {
            return $this->app_description;
        }
        function get_folder()
        {
            return $this->app_folder;
        }


        /**************************************************/
        /***************  INSTALL FUNCTION ****************/
        /**************************************************/
	function install()
	{
                $sql[] = "";
		foreach ($sql as $query)
		{
                    smp_execute($query);
		}
		return TRUE;
	}


        /**************************************************/
        /***************  DISABLE FUNCTION ****************/
        /**************************************************/
	function disable()
	{
		$sql[] = "";
		foreach ($sql as $query)
		{
			smp_execute($query);
		}
		return TRUE;
	}

        /**************************************************/
        /***************  ACTIVATE FUNCTION ****************/
        /**************************************************/
        function activate()
	{
		$sql[] = "";
		foreach ($sql as $query)
		{
			smp_execute($query);
		}
		return TRUE;
	}

        /**************************************************/
        /***************  UNINSTALL FUNCTION ****************/
        /**************************************************/
	function uninstall()
	{
		$sql[] = "";
		foreach ($sql as $query)
		{
			smp_execute($query);
		}
		return TRUE;
	}



        /**************************************************/
        /***************  UPGRADE FUNCTION ****************/
        /**************************************************/
	function upgrade()
	{
            $current_version = smp_lookup('version', 'global_modules', 'LOWER(title) = \''. $this->app_name .'\'');
            $module_id = smp_lookup('module_id', 'global_modules', 'LOWER(title) = \''. $this->app_name .'\'');
            
            if ($current_version == $this->app_version)
            {
                return true;
            }

            /* Upgrade to Version 1.1 */
            if ($current_version < 1.1)
            {
                $sql[] = "";

                foreach ($sql as $query)
		{
			smp_execute($query);
		}

                unset($sql); //unset sql array to clear any previous queries;

            }

            return TRUE;
	}


}
// END CLASS

/* End of file module_config.php */
/* Location: ./app/modules/config/module_config.php */