<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class PPDirect extends Controller {

    function __construct() {
            parent::Controller();
            $this->load->library('paypal_lib');
    }

    function ipn($productId, $gateway_id = 0)
    {
        // all variables sent by Paypal are in the ipn_data() array.
        //smp_log("Checking IPN Now....");
        if ($this->paypal_lib->validate_ipn())
        {
            //smp_log("IPN VERIFIED DUDE....");
            //$productId = $this->paypal_lib->ipn_data['item_number'];
            //smp_log("Product ID:" . $productId);

            $order['product_id'] = $productId;
            $order['productIdInDB'] = smp_lookUp("product_id", $this->config->item('tbl_product_gateways'), "product_id = " . $productId);
            $order['user_id'] = smp_lookUp("user_id", $this->config->item('tbl_users'), "email = '" . $this->paypal_lib->ipn_data['payer_email'] . "' OR paypal_id = '" . $this->paypal_lib->ipn_data['payer_email'] . "' ");
            if ($order['user_id'] == "" || $order['user_id'] < 1){
                // Create new user account
                $field_array['first_name'] = $this->paypal_lib->ipn_data['first_name'];
                $field_array['last_name'] = $this->paypal_lib->ipn_data['last_name'];
                $field_array['email'] = $this->paypal_lib->ipn_data['payer_email'];
                $field_array['username'] = $this->paypal_lib->ipn_data['payer_email'];
                $field_array['password'] = smp_getrandstring(8);
                $field_array['role_id'] = 2;
                $field_array['r_cre_time'] = smp_datetime();
                $field_array['r_mod_time'] = smp_datetime();
                $field_array['remote_addr'] = smp_getIp();
                $field_array['last_ip'] = smp_getIp();
                $this->db->insert($this->config->item('tbl_users'), $field_array);
                $order['user_id'] = $this->db->insert_id();
            }

            $order['user_name'] = smp_lookUp("username", $this->config->item('tbl_users'), "user_id = " . $order['user_id']);
            $order['user_password'] = smp_lookUp("password", $this->config->item('tbl_users'), "user_id = " . $order['user_id']);
            $order['user_email'] = smp_lookUp("email", $this->config->item('tbl_users'), "user_id = " . $order['user_id']);

            //$user_id = $this->paypal_lib->ipn_data['custom'];

            /* Verify for fraudulant transactions */
            //$gateway_id = smp_lookup('gateway_id', $this->config->item('tbl_product_gateways'), 'product_id = ' . $productId);
            //$business = smp_lookup('setting_1', $this->config->item('tbl_gateways'), 'gateway_id = ' . $gateway_id);
            //if (strcasecmp($this->paypal_lib->ipn_data['receiver_email'], $business) != 0) {
                //smp_log("[ppdirect.php]Received transaction with PayPal e-mail: " . $this->paypal_lib->ipn_data['receiver_email']);
                //exit;
            //}
            $channel = smp_lookup('title', $this->config->item('tbl_gateways'), 'setting_1 = \'' . $this->paypal_lib->ipn_data['receiver_email'] . '\'');
            if (!$channel){
                $channel = "Paypal";
            }

            if ($productId == $order['productIdInDB']) {
                $order['productName'] = smp_lookup("product_name", $this->config->item('tbl_products'), "product_id = " . $productId);
                $add_grp = smp_lookup("add_grp", $this->config->item('tbl_products'), "product_id = " . $productId);
                $remove_grp = smp_lookup("remove_grp", $this->config->item('tbl_products'), "product_id = " . $productId);
                $order['productReturnURL'] = smp_lookup("return_url", $this->config->item('tbl_products'), "product_id = "  . $productId);
                $order['productDuration'] = smp_lookup("expire_download", $this->config->item('tbl_products'), "product_id = " . $productId);
                //$kunaki_enabled = smp_lookup("kunaki_enabled", $this->config->item('tbl_products'), "product_id = " . $productId);
                //$kunaki_product_id = smp_lookup("kunaki_product_id", $this->config->item('tbl_products'), "product_id = "  . $productId);
                //$account_id = smp_lookup("account_id", $this->config->item('tbl_products'), "product_id = " . $productId);
                $order['autoresponder_unit'] = smp_lookup("autoresponder_unit", $this->config->item('tbl_products'), "product_id = " . $productId);
                //$autoresponder_service = EES_LookUp("key_value", "global_keyvalue", "key_id = (select autoresponder_service from shop_products where product_id = " . $db->ToSQL($productId, ccsInteger) .")", $db);
                $order['shop_notify_success'] = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'NOTIFY_SUCCESS'");
                $order['shop_notify_void'] = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'NOTIFY_VOID'");
                $tpl_email_sale_completed = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'TPL_EMAIL_NEW_ORDER_USER'");
                $tpl_email_sale_default = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'TPL_EMAIL_NEW_ORDER_USER'");
                $order['admin_email'] = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'ADMIN_EMAIL'");
                $order['admin_name'] = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'ADMIN_NAME'");

                if(isset($this->paypal_lib->ipn_data['quantity'])){
                    $productQuantity = $this->paypal_lib->ipn_data['quantity'];
                }
                else {
                    $productQuantity = 1;
                }
                $order['productBasicPrice'] = smp_lookup("price", $this->config->item('tbl_products'), "product_id = " . $productId);
            }
            else {
                smp_log("[ppdirect.php]Product ID Received [" . $productId . "] Doesnt Match With Product ID in DB [" . $order['productIdInDB'] . "]");
                exit;
            }

            if (isset($this->paypal_lib->ipn_data['mc_gross'])){
                $order['productGross'] = $this->paypal_lib->ipn_data['mc_gross'];
            }
            else{
                $order['productGross'] = $this->paypal_lib->ipn_data['pp_amount3'];
            }

            if (isset($this->paypal_lib->ipn_data['txn_id'])){
                $order['txn_id'] = $this->paypal_lib->ipn_data['txn_id'];
            }
            else{
                $order['txn_id'] = $this->paypal_lib->ipn_data['subscr_id'];
            }

            /* SET THE TRANSACTION CODE BASED ON THE PAYMENT STATUS RECEIVED */
            if (isset($this->paypal_lib->ipn_data['payment_status'])){
                $order['payment_status'] = strtolower($this->paypal_lib->ipn_data['payment_status']);
            }
            else{
                $order['payment_status'] = strtolower($this->paypal_lib->ipn_data['txn_type']);
            }
            //smp_log("PAYMENT STATUS: " . $payment_status);

            switch($order['payment_status'])
            {
                    case "subscr_cancel":
                    case "subscr_failed":
                    case "denied":
                    case "expired":
                    case "failed":
                    case "refunded":
                    case "reversed":
                    case "voided":
                            $order['trans_status_code'] = 0;
                    break;

                    case "pending":
                            $order['trans_status_code'] = 2;
                    break;

                    case "completed":
                    //case "subscr_signup":
                    //case "subscr_modify":
                    case "subscr_payment":
                            $order['trans_status_code'] = 1;
                            $order['payment_status'] = 'completed';
                    break;

                    default:
                    break;
            }
            //smp_log("STATUS CODE: " . $trans_status_code);

            $transStatusChange = "";
            $transUpdateUser = false;
            $flag_transaction_status = "";

            // CHECKING IF IT'S A NEW TRANSACTION OR A TRANSACTION STATUS UPDATE
            if (isset($this->paypal_lib->ipn_data['parent_txn_id'])){
                $where = "gateway_id = '" . $order['txn_id'] . "' OR gateway_id = '" . $this->paypal_lib->ipn_data['parent_txn_id'] . "'";
            }
            else {
                $where = "gateway_id = '" . $order['txn_id'] . "'";
            }

            if ($oldTransStatus = smp_lookup("transaction_status_details", $this->config->item('tbl_transactions'), $where)) {
                //smp_log("RECEIVED AN OLD TRANSACTION");
                $flag_transaction_status = "OLD";
                if ($oldTransStatus != $order['payment_status']) {
                    $transStatusChange = $order['payment_status'];

                    $this->db->where($where);
                    $field_array['transaction_status_details'] = $order['payment_status'];
                    $field_array['transaction_status_code'] = $order['trans_status_code'];
                    $this->db->update($this->config->item('tbl_transactions'), $field_array);
                    $flag_transaction_status = "OLDBUTUPDATE";
                }
            }
            else {
                $flag_transaction_status = "NEW";
                //smp_log("RECEIVED A NEW TRANSACTION");
            }

            if ($flag_transaction_status == "NEW" && $order['trans_status_code'] == 1){
                //smp_log("PROCESSING NEW RECORD");
                // CREATE NEW TRANSACTION RECORD
                if ($order['productDuration'] == 0){
                    $order['productDuration'] = 999;
                }
                //EES_AddToLog("PRODUCT DURATION: " . $productDuration);
                $order['expire_date'] = smp_add_days_to_date(smp_datetime(),$order['productDuration']);
                //EES_AddToLog("EXPIRY DATE FORMED: " . $collector_variable_expire_date);
                $field_array_transaction['transaction_date'] = smp_datetime();
                $field_array_transaction['begin_date'] = smp_datetime();
                $field_array_transaction['expire_date'] = $order['expire_date'];
                $field_array_transaction['transaction_memo'] = $this->paypal_lib->ipn_data['custom'];
                $field_array_transaction['currency_code'] = $this->paypal_lib->ipn_data['mc_currency'];
                $field_array_transaction['transaction_amount'] = $order['productGross'];
                $field_array_transaction['user_id'] = $order['user_id'];
                $field_array_transaction['gateway_id'] = $order['txn_id'];
                $field_array_transaction['transaction_status_details'] = $order['payment_status'];
                $field_array_transaction['transaction_type'] = 1;
                $field_array_transaction['transaction_category'] = 1;
                $field_array_transaction['transaction_title'] = $order['productName'];
                $field_array_transaction['transaction_status_code'] = $order['trans_status_code'];
                $field_array_transaction['channel'] = $channel;
                $this->db->insert($this->config->item('tbl_transactions'), $field_array_transaction);

                //smp_log("PAYPAL TRANSACTION ID: " . $txn_id);
                $orderId = smp_lookup("transaction_id", $this->config->item('tbl_transactions'), "gateway_id = '" . $order['txn_id'] . "'");
                //smp_log("LATEST TRANSACTION ID: " . $orderId);

                //smp_log("Inserting in Shop Order Items");
                $field_array_orderitems['quantity'] = $productQuantity;
                $field_array_orderitems['price'] = $order['productGross'];
                $field_array_orderitems['order_id'] = $orderId;
                $field_array_orderitems['product_id'] = $productId;
                $this->db->insert($this->config->item('tbl_order_items'), $field_array_orderitems);
                //smp_log("[ppdirect.php]Inserted in Shop Order Items");


                /* UPDATING USER GROUP IF SET IN PRODUCT CONFIGURATION */
                if ($add_grp > 0){
                    if ($remove_grp) {
                        $remove_grp = $remove_grp;
                    }
                    else {
                        $changeback_grp = 0;
                    }
                    if ($order['trans_status_code'] == 1){
                        $field_array_users['role_id'] = $add_grp;
                    }
                    if ($order['trans_status_code'] == 0 && $remove_grp > 0){
                        $field_array_users['role_id'] = $remove_grp;
                    }
                    $where = "user_id = " . $order['user_id'];
                    $this->db->update($this->config->item('tbl_users'), $field_array_users, $where);
                    //smp_log("UPDATED USER GROUP");
                }



                /* ADDING CUSTOMER TO AUTORESPONDER, IF SPECIFIED */
                if ($order['autoresponder_unit'] <> ""){
                    //smp_log("ADDING CUSTOMER TO AR");
                    // load email lib and email results
                    $data['subject'] = '[SUBSCRIBE]';
                    $data['message'] = '[SUBSCRIBE]';
                    $data['from'] = $order['user_email'];
                    $data['name'] = $this->paypal_lib->ipn_data['first_name'];
                    $data['to'] = $order['autoresponder_unit'];
                    smp_sendmail($data);
                    smp_log("[ppdirect.php]CUSTOMER ADDED TO AR");
                }

                /* NOTIFY SALE TO AFFILIATE PROGRAM --- STARTS */
                $notify_success = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'NOTIFY_SUCCESS'");
                //smp_log("NOTIFYING AFFILIATE PROGRAM");

                if ($notify_success<>"")
                {
                    $notify_fields = "";
                    $notify_url = "";

                    //$ipaddress=$_SERVER['REMOTE_ADDR'];
                    //$notify_url = str_replace("{SMP_IP}", $productName, $notify_url);

                    $notify_data = explode("?", $notify_success);
                    if(isset($notify_data[0])){
                          $notify_url = $notify_data[0];
                    }

                    if(isset($notify_data[1])){
                          $notify_fields = $notify_data[1];
                    }

                    $notify_fields = str_replace("{SMP_AMT}", $order['productGross'], $notify_fields);
                    $notify_fields = str_replace("{SMP_RECEIPT}", $order['txn_id'], $notify_fields);
                    $notify_fields = str_replace("{SMP_NAME}", $this->paypal_lib->ipn_data['first_name'], $notify_fields);
                    $notify_fields = str_replace("{SMP_EMAIL}", $this->paypal_lib->ipn_data['payer_email'], $notify_fields);
                    $notify_fields = str_replace("{SMP_PRODUCT}", $order['productName'], $notify_fields);
                    $notify_fields = urlencode($notify_fields);

                    smp_log("[ppdirect.php]Notify URL: " . $notify_url);
                    smp_log("[ppdirect.php]Notify Fields: " . $notify_fields);

                    if (function_exists('curl_init')){
                            $ch = curl_init();
                            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
                            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
                            curl_setopt($ch, CURLOPT_URL, $notify_url);
                            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                            curl_setopt($ch, CURLOPT_POST, 1);
                            //curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
                            curl_setopt($ch, CURLOPT_POSTFIELDS, $notify_fields);
                            $data = curl_exec($ch);
                            curl_close($ch);
                            //smp_log("########## NOTIFIED AFFILIATE URL  FOR ADDING COMMISSION ##########");
                    }
                    else {
                            smp_log("########## SERVER NOT CAPABLE TO NOTIFY VIA CURL ##########");
                    }
                }
                /* NOTIFY SALE TO AFFILIATE PROGRAM --- ENDS */

                /* FINALLY, NOTIFY CUSTOMER & ADMIN BY EMAIL --- STARTS */
                $emailTpl = "";
                $emailTpl = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'TPL_EMAIL_NEW_ORDER_USER'");
                //smp_log("NOTIFYING CUSTOMER");

                if ($emailTpl<>"")
                {
                    $emailTpl = str_replace("{first_name}", $this->paypal_lib->ipn_data['first_name'], $emailTpl);
                    $emailTpl = str_replace("{last_name}", $this->paypal_lib->ipn_data['last_name'], $emailTpl);
                    $emailTpl = str_replace("{download_link}", $order['productReturnURL'], $emailTpl);
                    $emailTpl = str_replace("{admin_name}", $order['admin_name'], $emailTpl);
                    $emailTpl = str_replace("{item_name}", $order['productName'], $emailTpl);
                    $emailTpl = str_replace("{username}", $order['user_name'], $emailTpl);
                    $emailTpl = str_replace("{password}", $order['user_password'], $emailTpl);

                    $data['subject'] = '[Your Order]:' . $order['productName'];
                    $data['message'] = $emailTpl;
                    $data['from'] = $order['admin_email'];
                    $data['name'] = $order['admin_name'];
                    $data['to'] = $order['user_email'];
                    $data['bcc'] = $order['admin_email'];
                    smp_sendmail($data);
                    smp_log("[ppdirect.php]CUSTOMER NOTIFIED BY EMAIL");
                }
                /* FINALLY, NOTIFY CUSTOMER & ADMIN BY EMAIL --- ENDS */

                /* Call after order hooks to process additional functionality */
                smp_hook($this->config->item('hook_shop_order_complete'), $order);

            }



        }
        else {
            smp_log("[ppdirect.php]IPN Failed");
        }
    }

}

/* End of file ppdirect.php */
/* Location: ./app/controllers/gateways/ppdirect.php */